<template>
  <div class="app-container">
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-col :span="20">
        <span>试玩开关设置：</span>
        <el-switch v-model="trialStatus"
                   active-color="#13ce66"
                   inactive-color="#ff4949"
                   active-text="启用"
                   inactive-text="停用"
                   :active-value="1"
                   :inactive-value="0"
                   @change="changeStatus($event)" >
        </el-switch>
      </el-col>
    </div>
    <el-table :data="tableData" style="width:100%" class="show_table"
              @sort-change="changeSort"
              :default-sort="{prop: 'sort', order: 'descending'}" >
      <el-table-column label="游戏编号" style="width:2%" align="center">
        <template slot-scope="scope">
          <span>{{scope.row.uid}}</span>
        </template>
      </el-table-column>

      <el-table-column label="ICON图标" style="width:30%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <img  v-if="scope.row.imageUrl" :src="scope.row.imageUrl" style="width: 130px;height: 70px;"/>
        </template>
      </el-table-column>
      <el-table-column label="游戏名称" style="width:30%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.name }}</span>
        </template>
      </el-table-column>
      <el-table-column label="排序权重" style="width:2%" prop="sort" :show-overflow-tooltip="true" align="center" sortable="custom" :sort-by="['sort']">
        <template slot-scope="scope">
          <span>{{ scope.row.sort }}</span>
        </template>
      </el-table-column>
      <!--      <el-table-column label="创建时间" style="width:4%" :show-overflow-tooltip="true" align="center">-->
      <!--        <template slot-scope="scope">-->
      <!--          <span>{{ scope.row.createTime }}</span>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
      <!--      <el-table-column label="更新时间" style="width:4%" :show-overflow-tooltip="true" align="center">-->
      <!--        <template slot-scope="scope">-->
      <!--          <span>{{ scope.row.updateTime }}</span>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
      <el-table-column label="开关设置" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.status"
                     :inactive-value="0"
                     :active-value="1"
                     active-text="启用"
                     inactive-text="停用"
                     active-color="#13CE66"
                     inactive-color="#FF4949"
                     @change="changeSwitch(scope.row)"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" fixed="right" style="width:3%">
        <template slot-scope="scope" >
          <el-button @click="handleEdit(scope.row)" type="primary" size="small" >编辑</el-button>
        </template>
      </el-table-column>

    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :close-on-click-modal="false" :visible.sync="dialogFormVisible" width="30%" :before-close="sortHandleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="编号" :label-width="formLabelWidth" prop="uid">
          <el-input v-model="form.uid" style="width:80%" :disabled="isEditForm"></el-input>
        </el-form-item>
        <el-form-item label="游戏名称" :label-width="formLabelWidth" prop="name">
          <el-input v-model="form.name" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="排序权重" :label-width="formLabelWidth" prop="sort">
          <el-input v-model="form.sort" style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="ICON图标" :label-width="formLabelWidth" prop="imageUrl">
          <div class="imgBody" v-if="form.imageUrl">
            <i class="el-icon-error inputClass" v-show="icon" @click="deletePhoto()" @mouseover="icon = true"></i>
            <img @mouseover="icon = true" @mouseout="icon = false" v-bind:src="form.imageUrl" style=" width: 100%;height: 100%;"/>
          </div>
          <el-upload  class="el-upload"
                      ref="upload"
                      v-model="imageUrl"
                      name="filedatas"
                      :action="url"
                      list-type="picture-card"
                      :limit="1"
                      :data="otherData"
                      :on-success="fileSuccess"
                      :on-preview="handlePictureCardPreview"
                      :on-remove="handleRemove">
            <i class="el-icon-plus"></i>
          </el-upload>
        </el-form-item>
        <el-form-item label="状态" :label-width="formLabelWidth" prop="status">
          <input type="radio" v-model="form.status" value="0">&nbsp; 停用 &nbsp;
          <input type="radio" v-model="form.status" value="1">&nbsp; 启用(默认) &nbsp;
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="submitForm">存储设置</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="atlasDialogPictureVisible" fullscreen style="text-align: center">
      <img :src="atlasDialogImageUrl" alt="">
    </el-dialog>
  </div>
</template>

<script>
    import {getGameConfigList,editGameConfig,changeAvailable} from "@/api/gameConfig";
    import AvatarCropper from '@/components/AvatarCropper';
    import { getToken } from '@/utils/auth'
    export default {
        components: {
            AvatarCropper
        },
        created() {
            this.getGameManagerList();
          this.otherData = {
            source: "picture",
            userUid: "1",
            adminUid: "1",
            projectName: "blog",
            sortName: "admin",
            token: getToken()
          };
        },

        data() {
            return {
                source: "1",
                direction: 'ltr',
                size: '100%',
                url: process.env.PICTURE_API + "/file/uploadPictures",
                atlasDialogImageUrl: "", //图片显示地址
                tableData: [],
                atlasTableData: [],//图集数据
                activeName:0,
                atlasData: [], //图集数据
                pictureData: [], //图片数据
                atlasQueryParams:{
                    uid:null,
                    name:null,
                    sortName:null,
                    sortUid:null,
                    status:null,
                    upCount:null,
                    outCount:null
                },
                atlasForm:{
                    uid: null,
                },
                form: {
                    uid: null,
                    name: null,
                    imageUrl: null,
                    fileUid: null,
                    sort: null,
                    status: null,
                },
                queryParams:{
                },
                title: null,
                isChange: false, // 表单内容是否改变
                changeCount: 0, // 改变计数器
                pictureUids: [], //图片uid集合
                resourceData: [], //标签数据
                tagValue: [], //保存选中标签id(编辑时)
                projectValue: null, //保存选中标签id(编辑时)
                tagData: [], //标签数据
                tagOptions: [], //标签候选框
                projectUid: null, //项目uid
                projectName: "全部", //项目名称
                projectOptions: [], //标签候选框
                multipleSelection: [], //多选，用于批量修改标签
                currentPage: 1,
                total: null,
                pageSize: 40,
                orderByDescColumn: "", // 降序字段
                orderByAscColumn: "", // 升序字段
                formLabelWidth: "120px", //弹框的label边框
                dialogFormVisible: false,
                atlasFormVisible: false,
                pictureFormVisible: false,
                atlasDialogPictureVisible: false,//当前分类图集列表
                isSortAdd: false,
                isEditForm: false,
                imageUrl: null,
                photoList: [],
                allProject:[],
                yesNoDictList: [], // 是否字典
                imagecropperKey: 0,
                imagecropperShow: false, //控制图片选择器的显示
                fileIds: "",
                icon: false, //控制删除图标的显示
                isFirstPhotoVisible: true, // 图片选择器是否首次显示【用于懒加载】
                rules: {
                    name: [
                        {required: true, message: '标题不能为空', trigger: 'blur'},
                        {min: 1, max: 150, message: '长度在1到150个字符'},
                    ],
                    sort: [
                        {required: true, message: '排序字段不能为空', trigger: 'blur'},
                        {pattern: /^[0-9]\d*$/, message: '排序字段只能为自然数'},
                    ],
                    status:[
                        {required: true, message: '状态不能为空', trigger: 'blur'},
                    ]
                }
            };
        },

        methods: {
            getGameManagerList: function() {
                this.queryParams.currentPage = this.currentPage;
                this.queryParams.pageSize = this.pageSize;
                this.queryParams.orderByDescColumn = this.orderByDescColumn
                this.queryParams.orderByAscColumn = this.orderByAscColumn
                getGameConfigList(this.queryParams).then(response => {
                    this.tableData = response.data.records;
                    this.currentPage = response.data.current;
                    this.pageSize = response.data.size;
                    this.total = response.data.total;
                });
            },
            changeSwitch: function(data){
                editGameConfig(data).then(response => {
                    this.$commonUtil.message.success(response.message)
                    this.dialogFormVisible = false;
                    this.getGameManagerList();
                });
            },
            //点击单选
            checked: function(data) {
                let idIndex = this.pictureUids.indexOf(data.uid);
                if (idIndex >= 0) {
                    //选过了
                    this.pictureUids.splice(idIndex, 1);
                } else {
                    this.pictureUids.push(data.uid);
                }
            },

            changeSort (val) {
                // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
                if(val.order == "ascending") {
                    this.orderByAscColumn = val.prop
                    this.orderByDescColumn = ""
                } else {
                    this.orderByAscColumn = ""
                    this.orderByDescColumn = val.prop
                }
                this.getGameManagerList();
            },

            handleFind: function() {
                this.currentPage = 1
                this.getGameManagerList();
            },
            getFormObject: function() {
                var formObject = {
                    uid: null,
                    name: null,
                    imageUrl: null,
                    fileUid: null,
                    status: 1,
                    sort: 0,
                };
                return formObject;
            },
            deletePhoto: function() {
                this.form.imageUrl = null;
                this.form.ava = "";
                this.icon = false;
            },
            checkPhoto() {
                this.photoList = [];
                this.fileUid = "";
                this.imagecropperShow = true;
                this.isFirstPhotoVisible = false
            },
            /**
             * 翻页事件
             */
            handleSizeChange(val) {
                this.pageSize = val;
                this.getGameManagerList();
            },
            //改变页码
            handleCurrentChange(val) {
                this.currentPage = val;
                this.getGameManagerList();
            },

            //点击新增
            handleAdd: function() {
                this.title = "新增游戏设置"
                this.isSortAdd = true
                this.dialogFormVisible = true;
                this.form = this.getFormObject();
                this.isEditForm = false;
            },
            //点击编辑
            handleEdit: function(row) {
                this.title = "编辑游戏设置"
                this.isSortAdd = false;
                this.dialogFormVisible = true;
                this.isEditForm = true;
                this.form = row;
            },


            showPicture: function(url) {
                this.atlasDialogPictureVisible = true
                this.atlasDialogImageUrl = url
            },

            submitForm: function() {
                this.$refs.form.validate((valid) => {
                    if(!valid) {
                        console.log("校验出错")
                    } else {
                        if (this.isEditForm) {
                            editGameConfig(this.form).then(response => {
                                this.$commonUtil.message.success(response.message)
                                this.dialogFormVisible = false;
                                this.getGameManagerList();
                            });
                        } else {
                            addGameConfig(this.form).then(response => {
                                if (response.code == this.$ECode.SUCCESS) {
                                    this.$commonUtil.message.success(response.message)
                                } else {
                                    this.$commonUtil.message.error(response.message)
                                }
                                this.dialogFormVisible = false;
                                this.getGameManagerList();
                            });
                        }
                    }
                })
            },
          handlePictureCardPreview(file) {
            this.atlasDialogPictureVisible = true;
            this.atlasDialogImageUrl = url
          },

          fileSuccess (response) {
            if (response.code == this.$ECode.SUCCESS) {
              let file = response.data;
              let photoList = []
              photoList.push(file[0].url);
              this.imageUrl = file[0].url
              this.form.imageUrl = file[0].url;
              this.form.fileUid = file[0].uid;
              this.$refs.upload.clearFiles();
              this.photoList = []

            }

          },
          handleRemove: function() {

          },

            // 改变多选
            handleSelectionChange(val) {
                this.multipleSelection = val;
            },

            upOrOutForm: function() {
                if (this.multipleSelection.length == 0){
                    this.$commonUtil.message.error("请选择图集")
                }else {
                    for(var i=0;i<this.multipleSelection.length;i++){
                        this.multipleSelection[i].sortUid = this.atlasQueryParams.sortUid;
                        this.multipleSelection[i].atlasUid = this.multipleSelection[i].uid;
                        if(this.atlasTitle == "上架中"){
                            this.multipleSelection[i].status = 0;
                        }else {
                            this.multipleSelection[i].status = 1;
                        }
                    }
                    upOrOut(this.multipleSelection).then(response => {
                        if (response.code == this.$ECode.SUCCESS) {
                            this.$commonUtil.message.success(response.message)
                        } else {
                            this.$commonUtil.message.error(response.message)
                        }
                        this.atlasFormVisible = false;
                        this.atlasQueryParams.name = null;
                        this.atlasQueryParams.status = null;
                        this.getGameManagerList();
                    });
                }

            },
            handlePicture(row) {
                // console.log("xx="+JSON.stringify(row));
                this.pictureFormVisible = true;
                this.atlasQueryParams.uid = row.uid;
                // query: { pictureAtlasUid: row.uid }
                this.pictureList();
            },

            pictureList() {
                var params = {};
                params.currentPage = 1;
                params.pictureAtlasUid = this.atlasQueryParams.uid;
                params.pageSize = 10000;
                getPictureList(params).then(response =>{
                    this.pictureData = response.data.records
                    // console.log("图片列表="+JSON.stringify(this.pictureData))
                });
            },

            handleClose(){
                this.atlasTableData = [];
                this.atlasQueryParams.name = null;
                this.atlasFormVisible = false;
            },

            pictureHandleClose(){
                this.pictureData = [];
                this.pictureFormVisible = false;
            },

            sortHandleClose(){
                this.dialogFormVisible = false;
                this.$refs.form.clearValidate();
                this.getGameManagerList();
            },

            cropSuccess(resData) {
                this.imagecropperShow = false
                this.imagecropperKey = this.imagecropperKey + 1
                let photoList = []
                photoList.push(resData[0].url);
                this.form.imageUrl = resData[0].url;
                this.form.fileUid = resData[0].uid
            },
            close() {
                this.imagecropperShow = false
            },

            deletePhoto: function() {
                this.form.imageUrl = null;
                this.form.ava = "";
                this.icon = false;
            },
            checkPhoto() {
                this.photoList = [];
                this.fileUid = "";
                this.imagecropperShow = true;
            },
          //点击开关
            changeStatus: function(status) {
              console.log('status:'+status);
              var obj={};
              obj.status=status;
              console.log('source:'+this.source);
              obj.source=this.source;
              console.log('obj:'+obj);
              changeAvailable(obj).then(response => {
                if(response.code == this.$ECode.SUCCESS) {
                  this.$commonUtil.message.success(response.message)
                } else {
                  this.$commonUtil.message.error(response.message)
                }
              })
                .catch(() => {})
            },
            setCover: function() {
                if (this.pictureUids.length != 1) {
                    this.$commonUtil.message.error("选择一张图片设为封面图")
                    return;
                }

                this.$confirm("是否将该图片设为封面？, 是否继续?", "提示", {
                    confirmButtonText: "确定",
                    cancelButtonText: "取消",
                    type: "warning"
                })
                    .then(() => {
                        let params = {};
                        params.uid = this.pictureUids[0]
                        params.pictureAtlasUid = this.atlasQueryParams.uid
                        setCover(params).then(response => {
                            this.$commonUtil.message.success(response.message)
                            this.pictureUids = [];

                            //再次查询图片
                            this.pictureList();
                        });
                    })
                    .catch(() => {
                        this.$commonUtil.message.info("已取消")
                    });
            },

        }
    }
</script>

<style scoped>
  .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    margin: 0, 0, 0, 10px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  .el-upload:hover {
    border-color: #409eff;
  }
  .avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 100px;
    height: 100px;
    line-height: 100px;
    text-align: center;
    border: 1px dashed #c0ccda;
    border-radius: 8px;
  }
  .inputClass {
    position: absolute;
  }
  .imgBody {
    width: 150px;
    height: 150px;
    border: solid 2px #ffffff;
    float: left;
    position: relative;
  }
  .uploadImgBody {
    margin-left: 5px;
    width: 100px;
    height: 100px;
    border: dashed 1px #c0c0c0;
    float: left;
    position: relative;
  }
  .uploadImgBody :hover {
    border: dashed 1px #00ccff;
  }
  .inputClass {
    position: absolute;
  }
  .show_table {
    background-color: #dde;
    width: 100%;
    height: 100%;
    overflow: auto;
    position: relative;
  }
</style>
